using Gee;
//using Posix;

void process_request (InputStream input, OutputStream output) throws Error {

     var headerMap = new HashMap<string, string>();
	 var queryMap = new HashMap<string, string>();

	var data_in = new DataInputStream (input);
	string line;
	while ((line = data_in.read_line (null)) != null) {
		//stdout.printf("%s\n",line);
		
		if(line.char_count()>=3){
			if(line.substring(0,3).ascii_casecmp("get")==0){
				//stdout.printf("get - request gefunden!\n");
				queryMap = query2HashMap(line, queryMap);	
				streamWaehlen(line.substring(13,4));
			}else{
				//stdout.printf("vor der methode");
				headerMap = header2hasmap(line, headerMap);
			}
		}
		
		if (line.strip () == "") break;
	}

	//queryMap testweise ausgeben
	
	stdout.printf ("\n\nQueryMap enthaelt: \n");
	foreach (var entry in queryMap.entries) {
		stdout.printf ("%s => %s\n", entry.key, entry.value);
	}
	stdout.printf ("----------------------------------------\n");

	//headerMap testweise ausgeben
	
	stdout.printf ("\n\nHeaderMap enthaelt: \n");
	foreach (var entry in headerMap.entries) {
		stdout.printf ("%s => %s\n", entry.key, entry.value);
	}
	stdout.printf ("----------------------------------------\n");
	
	
	var content = new StringBuilder();
	content.append("<html><h1>hier ist der pi mit wolfson sound-karte</h1>");
	content.append("dieser server wurde mit vala erstellt.");
	content.append("<table>");
	//
	content.append("<form method='get'>");
	content.append("<tr> <td><b>Stream stoppen:</b></td> <td><input type='submit' value='STOPP'/></td> </tr>");
	content.append("<input type='hidden' value='stop' name='action'/>");
	content.append("</form>");
	//	
	content.append("<form method='get'>");
	content.append("<tr> <td><b>FIP Groove:</b></td> <td><input type='submit' value='FIP GOOVE'/></td> </tr>");
	content.append("<input type='hidden' value='fgrv' name='action'/>");
	content.append("</form>");
	//
	content.append("<form method='get'>");
	content.append("<tr><td><b>FIP Jazz:</b></td><td><input type='submit' value='FIP JAZZ'/></td></tr>");
	content.append("<input type='hidden' value='fjzz' name='action'/>");
	content.append("</form>");
	//
	content.append("<form method='get'>");
	content.append("<tr><td><b>DLF:</b></td><td><input type='submit' value='DLF'/></td></tr>");
	content.append("<input type='hidden' value='dlfr' name='action'/>");
	content.append("</form>");
	//
	content.append("</table></html>");

	var header = new StringBuilder ();
	header.append ("HTTP/1.0 200 OK\r\n");
	header.append ("Content-Type: text/html\r\n");
	header.append_printf ("Content-Length: %lu\r\n\r\n", content.str.length);

	output.write (header.str.data);
	output.write (content.str.data);
	output.flush ();
}

int main (string[] args) {
	try {
	if(args.length != 2){
	   stdout.printf("Aufruf: gio-server port\n");
	}else{
		//stdout.printf("args[1]: %d\n",int.parse(args[1]));
	   var service = new SocketService ();
	   service.add_inet_port ((uint16)(int.parse(args[1])), null);
	   service.start ();
	   while (true) {
		var conn = service.accept (null);
		process_request (conn.input_stream, conn.output_stream);
	   }
	}
	} catch (Error e) {
	   stderr.printf ("%s\n", e.message);
	}
return 0;
}

void streamWaehlen(string auswahl){
	switch (auswahl){
       case "stop":
       	    Posix.system("echo stop; killall mplayer");
     	    break;
       case "fgrv":
       	 Posix.system(
	  "echo fip groove&& killall mplayer; mplayer -cache 1048 http://direct.fipradio.fr/live/fip-webradio3.mp3&");
     	    break;
       case "fjzz":
       	 Posix.system(
	  "echo fip groove&& killall mplayer; mplayer -cache 1048 http://direct.fipradio.fr/live/fip-webradio2.mp3&");
     	    break;
       case "dlfr":
       	    Posix.system(
	    "echo dlf&& killall mplayer;  mplayer -cache 1048 -playlist http://www.deutschlandradio.de/streaming/dlf_hq_ogg.m3u&");
     	    break;
   }
}

HashMap<string, string> header2hasmap(string line, HashMap<string, string> map){
	//ersten doppelpunkt in einer headerzeile suchen
	int position = line.index_of_char(':',0);
	string name = line.substring(0,position).strip();
	string value = line.substring(position+1).strip();
/*
  foreach (var s in feld){
  stdout.printf("%s<-> ",s);
  }
  stdout.printf("\n--------\n\n");
*/
	map.set(name, value);
	
	//stdout.printf("name: %s\tvalue: %s\n",name, value);
	return map;
}

HashMap<string, string> query2HashMap(string line, HashMap<string, string> map){
	//?-zeichen in der request-line suchen
	int startQueryString = line.index_of_char('?',0);
	//ende queryString suchen
	int endeQueryString =  line.index_of_char(' ',startQueryString);
    //queryString ausschneiden
	string queryString = line.substring(startQueryString+1, endeQueryString-startQueryString);

	//stdout.printf("query-string: %s\n", queryString);

	//query-string in key-value-paare splitten
	string[] keyVals = queryString.split("&");

	//ueber array mit key-value-paaren iterieren
	foreach (var s in keyVals){
		//pos von '=' zeichen suchen
		int i = s.index_of_char('=',0);
		//substrings als key-value in map eintragen
		map.set(s.substring(0,i),s.substring(i+1));
//		stdout.printf ("key:%s, value:%s\n",s.substring(0,i), s.substring(i+1));
	}
	return map;
}
